<!-- selected character view -->
<div *ngIf="characterCardDetail">
    <div class="d-flex justify-content-center clearfix">
        <div class="card character-card-detail">
            <div class="card-horizontal">
                <div class ="text-center img-div">
                    <img class="character-img rounded" [src]="characterDetails.image" alt="Card image cap">
                </div> 
                <div class="card-body character-detail">
                    <div class="card-title">{{ characterDetails.name }}</div>
                    <div>Species : {{ characterDetails.species }}</div>
                    <div>Gender: {{ characterDetails.gender }}</div>
                    <div>Location: <span (click)="characterLocation(characterDetails.location)" class="link">{{ characterDetails.location.name }}</span></div>
                    <div>Origin: <span (click)="characterLocation(characterDetails.location)" class="link">{{ characterDetails.origin.name }}</span></div>
                    <button (click)="back()" class="btn btn-view-char float-right">back</button>
                    <div>Episode List: </div>
                    <div class="container">
                        <div class="row">
                            <div class="col-3" *ngFor="let episode of episodeList;">
                                <div class="col-12 link" (click)="viewEpisodeDetails(episode)">{{ episode.name }} </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- character main group view -->
<div *ngIf="characterCardView" class="character-container">
    <div class="collapse-container">
        <button 
            type="button" 
            class="btn btn-collapse" 
            (click)="collapse.toggle()" 
            [attr.aria-expanded]="!isCollapsed"
            aria-controls="collapseExample"
            text='toggle'
        >
            {{ isCollapsed === true ? '-' : '+'}}
        </button>
        <span class="collapse-text">Character List</span>
    </div>


    <div #collapse="ngbCollapse" class="containersx" [(ngbCollapse)]="isCollapsed">
        <div class="row d-flex justify-content-center">
            <div *ngFor="let character of inputData['results']; let i = index;" [ngClass]="{'border-selected': selectedIndex === i}">
                <div class="card character-card">
                    <div class ="text-center img-div">
                        <img class="card-img-top character-img rounded" [src]="character.image" alt="Card image cap">
                    </div> 
                    <div class="card-body character-body">
                        <div class="card-name text-center"> {{ character.name }}</div>
                        <div>Species : {{ character.species }}</div>
                        <div>Gender: {{ character.gender }}</div>
                        <div>Location: {{ character.location.name }}</div>
                        <button (click)="viewCharacterDetails(character, i)" class="btn float-right btn-view-char">View Details</button>
                    </div>
                    <div class="card-footer text-center">
                        <span [ngClass]="
                            {
                                'alive': character.status == 'Alive',
                                'dead': character.status == 'Dead', 
                                'unknown': character.status == 'unknown'
                            }">•</span> {{ character.status }}
                    </div>
                </div>
            </div>
        </div>
        <div class="d-flex justify-content-around">
            <button [disabled]="inputData['info'].prev == null" (click)="prev(inputData['info'].prev)" class="btn btn-view-char">prev</button>
            <button [disabled]="inputData['info'].next == null" (click)="next(inputData['info'].next)" class="btn btn-view-char">next</button>
        </div>
    </div>
</div>


<!-- location main group view -->
<div *ngIf="locationCardView" class="location-container">
    <div class="collapse-container">
        <button 
            type="button" 
            class="btn btn-collapse" 
            (click)="collapse.toggle()" 
            [attr.aria-expanded]="!isCollapsed"
            aria-controls="collapseExample"
            text='toggle'
        >
            {{ isCollapsed === true ? '-' : '+'}}
        </button>
        <span class="collapse-text">Location List</span>
    </div>

    <div #collapse="ngbCollapse" [(ngbCollapse)]="isCollapsed">
        <div class="row d-flex justify-content-center containersx">
            <div *ngFor="let location of inputData['results']; let i = index;" [ngClass]="{'border-selected': selectedIndex === i}">
                <div class="card location-card">
                    <div class="card-body character-body">
                        <div class="card-title">{{ location.name }}</div>
                        <div>Type : {{ location.type }}</div>
                        <div>Dimension: {{ location.dimension }}</div>
                        <div>Known Resident Count: {{ location.residentCounts }}</div>
                        <button 
                            (click)="viewLocationDetails(location, i)" 
                            class="btn btn-view-char float-right" 
                            [disabled]="location.residentCounts == 0"
                        >View Residents</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="d-flex justify-content-around">
            <button [disabled]="inputData['info'].prev == null" (click)="prev(inputData['info'].prev)" class="btn btn-view-char">prev</button>
            <button [disabled]="inputData['info'].next == null" (click)="next(inputData['info'].next)" class="btn btn-view-char">next</button>
        </div>
    </div>
</div>

<!-- episode main group view -->
<div *ngIf="episodeCardView" class="location-container">
    <div class="collapse-container">
        <button 
            type="button" 
            class="btn btn-collapse" 
            (click)="collapse.toggle()" 
            [attr.aria-expanded]="!isCollapsed"
            aria-controls="collapseExample"
            text='toggle'
        >
            {{ isCollapsed === true ? '-' : '+'}}
        </button>
        <span class="collapse-text">Episode List</span>
    </div>

    <div #collapse="ngbCollapse" [(ngbCollapse)]="isCollapsed">
        <div class="row d-flex justify-content-center containersx">
            <div *ngFor="let episode of inputData['results']; let i = index;" [ngClass]="{'border-selected': selectedIndex === i}">
                <div class="card episode-card">
                    <div class="card-body character-body">
                        <div class="card-title">{{ episode.name }}</div>
                        <div>Aired : {{ episode.air_date }}</div>
                        <div>Episode: {{ episode.episode }}</div>
                        <div>Character shown: {{ episode.characterCount }}</div>
                        <button 
                            (click)="viewEpisodeDetails(episode, i)" 
                            class="btn btn-view-char float-right" 
                            [disabled]="episode.characterCount == 0"
                        >View Characters</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="d-flex justify-content-around">
            <button [disabled]="inputData['info'].prev == null" (click)="prev(inputData['info'].prev)" class="btn btn-view-char">prev</button>
            <button [disabled]="inputData['info'].next == null" (click)="next(inputData['info'].next)" class="btn btn-view-char">next</button>
        </div>
    </div>
</div>

<!-- character sub group view -->
<div *ngIf="subGroupCharacter" class="character-container">
    <div class="collapse-container">
        <button 
            type="button" 
            class="btn btn-collapse" 
            (click)="collapse.toggle()" 
            [attr.aria-expanded]="!isCollapsedSub"
            aria-controls="collapseExample"
            text='toggle'
        >
            {{ isCollapsedSub === true ? '-' : '+'}}
        </button>
    </div>

    <div #collapse="ngbCollapse" [(ngbCollapse)]="isCollapsedSub">
        <div class="info">
            <div *ngIf="subLocationShow" >
                <div class="details-title">List of residents on this Dimension</div>
                <div class="details">
                    <div><span style="font-weight: bold;">Name: </span> {{ locationDetails.name }} ({{ locationDetails.type }})</div>
                    <div><span style="font-weight: bold;">Dimension:</span> {{ locationDetails.dimension }}</div>
                    <div><span style="font-weight: bold;">Number of residents known: </span> {{ locationDetails.residentCounts }} </div>
                    <div><span style="font-weight: bold;">Created </span> {{ locationDetails.created }} </div>
                </div>
            </div>
            <div *ngIf="subEpisodeShow" >
                <div class="details-title">List of characters shown on this Episode</div>
                <div class="details">
                    <div><span style="font-weight: bold;">Name: </span> {{ episodeDetails.name }}</div>
                    <div><span style="font-weight: bold;">Aired:</span> {{ episodeDetails.air_date }}</div>
                    <div><span style="font-weight: bold;">Number of characters shown: </span> {{ episodeDetails.characterCount }} </div>
                    <div><span style="font-weight: bold;">Created: </span> {{ episodeDetails.created }} </div>
                </div>
            </div>
        </div>
        <div class="row d-flex justify-content-center">
            <div *ngFor="let character of characterData;">
                <div class="card character-card">
                    <div class ="text-center img-div">
                        <img class="card-img-top character-img rounded" [src]="character.image" alt="Card image cap">
                    </div> 
                    <div class="card-body character-body">
                        <div>Name: {{ character.name }}</div>
                        <div>Species : {{ character.species }}</div>
                        <div>Gender: {{ character.gender }}</div>
                        <div>Location: {{ character.location.name }}</div>
                        <button (click)="viewCharacterDetails(character)" class="btn btn-view-char float-right">View Details</button>
                    </div>
                    <div class="card-footer text-center">
                        <span [ngClass]="
                            {
                                'alive': character.status == 'Alive',
                                'dead': character.status == 'Dead', 
                                'unknown': character.status == 'unknown'
                            }">•</span> {{ character.status }}
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>